This is a package to integrate the DRP LDAP Authentication with Laravel 5.2.

It is a wrapper for [Adldap2 Laravel](https://github.com/Adldap2/Adldap2-Laravel) that includes a pre-configured config file, database migrations to add the username to the user table and adds the feature to check the LDAP groups



# Requirements

ldap-authentication requires PHP 5.5 and both the LDAP (http://php.net/ldap) and SSL (http://php.net/openssl) libraries

ldap-authentication requires laravel/framework version 5.2

# Installation

### Add to composer:

Add the Drp composer repository to your composer.json

```
"repositories": [
{
"type": "composer",
"url": "http://composer.drp.digital"
}
]
```

And also add the package to you requirements

```
"drp/ldap-authentication": "dev-master"
```

### Add to application:

After updating composer, add the ServiceProvider to the providers array in config/app.php

```
 Drp\LdapAuthentication\DrpldapServiceProvider::class
```

Copy the package config to your local config with the publish command:

```
php artisan vendor:publish
```

To add the username fields to the user table run

```
php artisan migrate
```

### Configure Ldap:

Add the Ldap provider in the auth config file (config/app.php). The name of this provider must be the same as the 'provider' option in your Ldap config.

```
'ldap' => [
'driver' => 'ldap',
'model' => App\User::class,
],
```

The Ldap config file relies on the ```LDAP_PASSWORD``` ENV variable, please obtain this from a SysAdmin


# Usage


You **must** insert the trait `Adldap\Laravel\Traits\AdldapUserModelTrait` onto your configured auth User model, **OR**
Add the public property `adldapUser` to your model.

Please see [Adldap2 Laravel](https://github.com/Adldap2/Adldap2-Laravel) for usage of the basic LDAP auth.


### Group checking

In the adldap config is the ```allowed_groups``` option, this is defaulted to 'All' to let any Drp Ldap user have permission. To restrict the level of the logged in user alter this option to match the Ldap permission groups setup by IT.

Example: ```'allowed_groups' => ['SG - DRP Digital Media', 'developer']```

